//-----------------------------------------------------------------------
// File : AsDemoCamera.h
// Desc : Asura Camera For Demo Application
// Copyright(c) Project Asura All right reserved.
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// History
//-----------------------------------------------------------------------
// <---> 2011/04/16 [Pocol] VK쐬
// <End>

#ifndef __ASURA_DEMO_CAMERA_H__
#define __ASURA_DEMO_CAMERA_H__

//-----------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------
#include "AsDef.h"
#include "AsMath.h"
#include "AsDemoApp.h"


namespace Schaft {
namespace Asura {
namespace SampleProgram {

/////////////////////////////////////////////////////////////////////////
// DemoCamera class
/////////////////////////////////////////////////////////////////////////
class DemoCamera
{
    //-------------------------------------------------------------------
    // list of friend classes and methods
    //-------------------------------------------------------------------
    /* NOTHING */

public:
    //-------------------------------------------------------------------
    // public variables
    //-------------------------------------------------------------------
    enum 
    {
        CAMERA_TYPE_THIRD_PERSON = 0,
        CAMERA_TYPE_FIRST_PERSON,
        NUM_CAMERA_TYPE
    };

    //-------------------------------------------------------------------
    // public methods
    //-------------------------------------------------------------------
    DemoCamera();
    virtual ~DemoCamera();
    void SetType( int type );
    void SetPosition( Schaft::Asura::Math::Vector3 position );
    void SetDirection( Schaft::Asura::Math::Vector3 direction );
    void SetUpVector( Schaft::Asura::Math::Vector3 upvector );
    void Compute();
    int  GetType();
    Schaft::Asura::Math::Vector3 GetPosition();
    Schaft::Asura::Math::Vector3 GetDirection();
    Schaft::Asura::Math::Vector3 GetUpVector();
    Schaft::Asura::Math::Matrix GetView();

protected:
    //-------------------------------------------------------------------
    // protected variables
    //-------------------------------------------------------------------
    typedef struct _MouseState
    {
        int cursorX;
        int cursorY;
        bool isDrag;
    } MouseState;

    int mType;
    MouseState mLeft;
    MouseState mRight;
    MouseState mMiddle;
    Schaft::Asura::Math::Vector2 mAngle;
    float   mDistance;

    //-------------------------------------------------------------------
    // protected methods
    //-------------------------------------------------------------------
    void ComputeThirdPersonCamera();
    void ComputeFirstPersonCamera();

private:
    //-------------------------------------------------------------------
    // private variables
    //-------------------------------------------------------------------
    Schaft::Asura::Math::Vector3 mPosition;
    Schaft::Asura::Math::Vector3 mDirection;
    Schaft::Asura::Math::Vector3 mUpVector;
    Schaft::Asura::Math::Matrix mView;

    //-------------------------------------------------------------------
    // private methods
    //-------------------------------------------------------------------
    /* NOTHING */
};

} // namespace SampleProgram
} // namespace Asura
} // namespace Schaft


#endif//__ASURA_DEMO_CEMERA_H__