//----------------------------------------------------------------------
// File : AsTextureUtil.h
// Desc : Asura Texture Util
// Copyright(c) Project Asura All right reserved.
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// History
//----------------------------------------------------------------------
// <---> 2011/04/06 [Pocol] VK쐬
// <End>

#ifndef __ASURA_TEXTURE_UTIL_H__
#define __ASRUA_TEXTURE_UTIL_H__

//----------------------------------------------------------------------
// Includes
//----------------------------------------------------------------------
#include <GL/glew.h>
#include "AsDef.h"
#include "AsTexture.h"

namespace Schaft {
namespace Asura {
namespace Util {

////////////////////////////////////////////////////////////////////////
// TextureData Class
////////////////////////////////////////////////////////////////////////
class TextureData
{
    //------------------------------------------------------------------
    // list of friend classes
    //------------------------------------------------------------------
    /* NOTHING */

public:
    //------------------------------------------------------------------
    // public variables
    //------------------------------------------------------------------
    /* NOTHING */

    //------------------------------------------------------------------
    // public methods
    //------------------------------------------------------------------
    TextureData();
    virtual ~TextureData();
    virtual void    Release();
    uint32_t        LoadFromDDS( const char *filename );
    uint32_t        GetWidth();
    uint32_t        GetHeight();
    uint16_t        GetBitsPerPixel();
    uint32_t        GetTextureFormat();

protected:
    //------------------------------------------------------------------
    // protected variables
    //------------------------------------------------------------------
    Schaft::Asura::Graphics::ITexture*  mpInterface;
    Schaft::Asura::Graphics::ITextureLoader* mpLoader;

    //------------------------------------------------------------------
    // protected methods
    //------------------------------------------------------------------
    uint32_t SetupTextureDDS();

private:
    //------------------------------------------------------------------
    // private variables
    //------------------------------------------------------------------
    /* NOTHING */

    //------------------------------------------------------------------
    // private methods
    //------------------------------------------------------------------
    /* NOTHING */
}; 


} // namespace Util
} // namespace Asura
} // namespace Schaft

#endif//__ASURA_TEXTURE_UTIL_H__